//---------------------------------------------------------------------------

#include <windows.h>
#include <Tchar.h>
//#include <shellapi.h>
#pragma hdrstop

#pragma argsused
//---------------------------------------------------------------------------
void RestoreDefaults()
{
   HKEY  RegKeyHandle;
   TCHAR LogonFN[MAX_PATH] = "logonui.exe";
   if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
   _TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon"),
      0, KEY_WRITE, &RegKeyHandle) != ERROR_SUCCESS)
         exit(EXIT_FAILURE);
   RegSetValueEx(RegKeyHandle, _TEXT("UIHost"), 0, REG_EXPAND_SZ,
                 LogonFN, lstrlen(LogonFN)*sizeof(TCHAR));
   RegFlushKey(RegKeyHandle);
   RegCloseKey(RegKeyHandle);
}
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{

   typedef
      struct FileNamesList
      {
         TCHAR          FileName[MAX_PATH];
         int            Num;
         FileNamesList  *NextItem;
      } FileNamesList, *PFileNamesList;
   const TCHAR          *FindDir    = _TEXT("logonuis\\");
   const TCHAR          *FindMask   = _TEXT("*.exe");
   TCHAR                FullFileName[MAX_PATH];
   WIN32_FIND_DATA      FindData;
   HANDLE               FindFileHandle;
   PFileNamesList       FirstElem = NULL, CurElem = NULL;
   int                  FileNum = 0;
   HKEY                 RegKeyHandle;

   if (!lstrcmp(lpCmdLine, "--restore"))
   //   logonui
   {
      RestoreDefaults();
      exit(EXIT_SUCCESS);
   }

   if (!lstrcmp(lpCmdLine, "--install"))
   //     
   {
      exit(EXIT_SUCCESS);
   }

   HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Group Policy\State\Machine\Scripts\Shutdown\0\0

   if (lstrcmp(lpCmdLine, "--accept")) {
      MessageBox(NULL, _TEXT("!     "
      "     .\n   "
      "    !\n   ,  "
      " ,    !\n :"
      "\n\t1.)    %Windir%\\system32"
      "\n\t2.)   \"logonuis\""
      "\n\t3.)    logonuis 1    "
      "\n\t4.)    --install"
      "\n\t5.)    --restore    "
      " "
      "\n\n--=-=-- Created by Artiom N.(cl)2006 --=-=--\n"),
      _TEXT("!"), MB_ICONWARNING | MB_OK | MB_SYSTEMMODAL);
      exit(EXIT_FAILURE);
   }
   
   GetSystemDirectory(FullFileName, MAX_PATH);
   lstrcat(FullFileName, _TEXT("\\"));
   lstrcat(FullFileName, FindDir);
   lstrcat(FullFileName, FindMask);
   if ((FindFileHandle = FindFirstFile(FullFileName, &FindData))
      == INVALID_HANDLE_VALUE) exit(EXIT_FAILURE);
   randomize();
   FirstElem = new FileNamesList;
   lstrcpy(FirstElem->FileName, FindData.cFileName);
   FirstElem->NextItem  = NULL;
   FirstElem->Num       = 0;
   while(FindNextFile(FindFileHandle, &FindData)) {
      CurElem = new FileNamesList;
      lstrcpy(CurElem->FileName, FindData.cFileName);
      CurElem->Num         = ++FileNum;
      CurElem->NextItem    = FirstElem->NextItem;
      FirstElem->NextItem  = CurElem;
   }
   FindClose(FindFileHandle);

   FileNum = random(FileNum + 1);
   CurElem = FirstElem;
   while (CurElem) {
      if (CurElem->Num == FileNum) {
         if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,
            _TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon"),
            0, KEY_WRITE, &RegKeyHandle) != ERROR_SUCCESS)
               exit(EXIT_FAILURE);
/*            RegQueryValueEx(RegKeyHandle, _TEXT("UIHost"), 0, NULL,
               CurFileName, &CFNameSize);
*/
         lstrcpy(FullFileName, FindDir);
         lstrcat(FullFileName, CurElem->FileName);
         RegSetValueEx(RegKeyHandle, _TEXT("UIHost"), 0, REG_EXPAND_SZ,
            FullFileName, lstrlen(FullFileName)*sizeof(TCHAR));
         RegFlushKey(RegKeyHandle);
         RegCloseKey(RegKeyHandle); 
         break;
      }
      CurElem = CurElem->NextItem;
   }

   do {
      CurElem     = FirstElem;
      FirstElem   = CurElem->NextItem;
      delete CurElem;
   } while (FirstElem);
   return 0;
}
//--------------------------------------------------------------------------

